/*assignment #6 */
//Programmer- Kevin Korpi

/* Rotating cube with color  */


#include <GL/glut.h>


GLfloat vertices[][3] = {{0.0, 0.0, 0.0}, {1.0, 0.0, 0.0},
			 {1.0, 1.0, 0.0}, {0.0, 1.0, 0.0}, {0.0, 0.0, 1.0},
			 {1.0, 0.0, 1.0}, {1.0, 1.0, 1.0}, {0.0, 1.0, 1.0}};


GLfloat colors[][3] = {{1.0, 0.0, 0.0}, {0.0, 0.0, 1.0},
		       {0.0, 1.0, 0.0}, {0.4, 0.0, 1.0}, {1.0, 0.4, 0.2},
		       {1.0, 0.0, 1.0}, {0.0, 0.0, 0.0}, {0.0, 0.0, 0.0}};

void polygon(int a, int b, int c , int d)
{

/* draw a polygon via list of vertices */

        glBegin(GL_POLYGON);
                glColor3fv(colors[a]);
		glVertex3fv(vertices[a]);
		glVertex3fv(vertices[b]);
		glVertex3fv(vertices[c]);
		glVertex3fv(vertices[d]);
        glEnd();
               }

void colorcube(void)
{

/* map vertices to faces */

  polygon(0, 3, 2, 1);
  polygon(2, 3, 7, 6);
  polygon(3, 0, 4, 7);
  polygon(1, 2, 6, 5);
  polygon(4, 5, 6, 7);
  polygon(5, 4, 0, 1);

}

static GLfloat theta[] = {0.5, 0.5, 0.5};

void display(void)
{

 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        glLoadIdentity();
	gluLookAt(1.0, 1.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
	glRotatef(theta[0], 1.0, 0.0, 0.0);
	glRotatef(theta[1], 0.0, 1.0, 0.0);
	glRotatef(theta[2], 0.0, 0.0, 1.0);

 colorcube();
 glRotatef(2.0, 0.0, 1.0, 0.0);

 glFlush();
        glutSwapBuffers();
}

GLint axis = 1; // spin upon Y axis
void spinCube()
{

/* Idle callback, spin cube 2 degrees about selected axis */

	theta[axis] += 2.0;
	if( theta[axis] > 360.0 ) theta[axis] -= 360.0;

	glutPostRedisplay();
}

void mouse(int btn, int state, int x, int y)
{

  if(btn==GLUT_LEFT_BUTTON && state == GLUT_DOWN) axis = 4;
  if(btn==GLUT_LEFT_BUTTON && state == GLUT_UP) axis = 1;

}

void mykey(int key)
{
  if (key == 'Q' || key == 'q') exit(0);
  if (key == 'X' || key == 'x') axis = 0;
  if (key == 'Y' || key == 'y') axis = 1;
  if (key == 'Z' || key == 'z') axis = 2;

        glBegin(GL_POLYGON);
}

void myReshape(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (w <= h)
      glOrtho(-2.0, 2.0, -2.0 * (GLfloat) h / (GLfloat) w,
            2.0 * (GLfloat) h / (GLfloat) w, -10.0, 10.0);
    else
        glOrtho(-2.0 * (GLfloat) w / (GLfloat) h,
	      2.0 * (GLfloat) w / (GLfloat) h, -2.0, 2.0, -10.0, 10.0);
  glMatrixMode(GL_MODELVIEW);
}

void
main(int argc, char **argv)
{
  glutInit(&argc, argv);

  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(500, 500);
      glBegin(GL_POLYGON);
  glutCreateWindow("simple colorcube");
  glutReshapeFunc(myReshape);
  glutDisplayFunc(display);
  glutIdleFunc(spinCube);
  glutMouseFunc(mouse);
  glutKeyboardFunc(mykey);
  glEnable(GL_DEPTH_TEST);
  glutMainLoop();
}
